#include <assert.h>
#ifndef ASSERT
#define ASSERT(a) assert((a))
#endif

#define DWORD unsigned long
typedef unsigned char byte;

class CBitArray
{
protected:
	byte *b_arr;
	size_t all_bits,all_bytes,last_bits;
public:
	CBitArray(size_t size)
	{
		all_bits=size;
		all_bytes=(size>>3)+((last_bits=size&7)?1:0);
		b_arr=new byte[all_bytes];
	}
	virtual ~CBitArray() { delete[] b_arr; }

	byte GetBit(size_t bit_num);
	void SetBit(size_t bit_num,byte bit_val);

	CBitArray& operator= (CBitArray &arg);
	CBitArray(CBitArray &arg);

	friend CBitArray operator& (CBitArray &a,CBitArray &b);
	friend CBitArray operator| (CBitArray &a,CBitArray &b);
	friend CBitArray operator^ (CBitArray &a,CBitArray &b);
	friend CBitArray operator~ (CBitArray &a);
	friend int       operator== (CBitArray &a,CBitArray &b);
};

